// same as GUID_DEVINTERFACE_PARALLEL and GUID_PARALLEL_DEVICE (111022)
DEFINE_GUID(Vlpt_GUID,0x97F76EF0L,0xF883,0x11D0,0xAF,0x1F,0x00,0x00,0xF8,0x00,0x84,0x5C);

#define Vlpt_CTL(a,b) CTL_CODE(FILE_DEVICE_UNKNOWN,0x0800+(a),METHOD_##b,FILE_ANY_ACCESS)

/* Schreiben und (optional) anschlieendes Lesen von Daten
   ber die beiden Pipes zum USB2LPT-Konverter.
   Asynchron-fhig!
   ShortTransferOK, dh. USB-Gert darf auch
   einen krzeren Datenblock zurcksenden.
   ACHTUNG: InBuffer sind (Bulk)OUT-Daten, OutBuffer (Bulk)IN-Daten! */
#define IOCTL_VLPT_OutIn		Vlpt_CTL(4,BUFFERED)
